#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void* ma_fonction(void* x){
  printf("THREAD : je suis %d et tente d'entrer dans le lit critique\n",*(int*)x);
  pthread_mutex_lock(&mutex);
  printf("THREAD : je suis %d et profite du lit critique\n",*(int*)x);
  sleep(2);
  pthread_mutex_unlock(&mutex);
  pthread_exit(NULL);
}

int main(){
  int i=0;
  int numeros[4] = {1,22,333,4444};
  //threads
  pthread_t mes_threads[4];
  printf("PROCESSUS : je lance les threads !\n");
  for(i=0;i<4;i++){
    pthread_create(&mes_threads[i],NULL,&ma_fonction,&numeros[i]);
  }
  printf("PROCESSUS : j'attends les threads !\n");
  for(i=0;i<4;i++){
    pthread_join(mes_threads[i],NULL);
    printf("PROCESSUS : %d est arrive.\n",numeros[i]);
  }
  printf("PROCESSUS : ils sont tous arrivés.\n");
  pthread_mutex_destroy(&mutex);
  return 0;
}

